package sample;

import javax.swing.Icon;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;

public class SwingL2Table extends JTable {

	private static final long serialVersionUID = 1L;
	
	private final DefaultTableModel tableModel;
	
	private static class SwingL2TableModel extends DefaultTableModel {
		private static final long serialVersionUID = 1L;

		@Override
		public Class<?> getColumnClass(int columnIndex) {
			return String.class;
		}
	}
	
	public SwingL2Table(String label) {
		tableModel = new SwingL2TableModel();
		tableModel.setColumnIdentifiers(new String[] {label + " Price", label + " Volume", label + " Time", "Order Code", "Market Maker ID"});
		
		super.setModel(tableModel);
		super.setEnabled(false);
		
		super.getColumnModel().getColumn(0).setPreferredWidth(50);
		super.getColumnModel().getColumn(1).setPreferredWidth(50);
		super.getColumnModel().getColumn(2).setPreferredWidth(50);
		super.getColumnModel().getColumn(3).setPreferredWidth(100);
		super.getColumnModel().getColumn(4).setPreferredWidth(100);
	}
	
	@Override
	public void setValueAt(Object value, int rowIndex, int columnIndex) {
		tableModel.setValueAt(value, rowIndex, columnIndex);
	}
	
	public void insertRow(int rowIndex, String price,
			String volume, String time, String order_code, String maker) {
		String[] row = {price, volume, time, order_code, maker};
		tableModel.insertRow(rowIndex, row);
	}
	
	@Override
	public int getRowCount() {
		return tableModel.getRowCount();
	}
	
	public void setRowCount(int rowCount) {
		tableModel.setRowCount(rowCount);
	}
	
	public void removeRow(int index) {
		tableModel.removeRow(index);
	}
	
	public String getValueAt(int row, int column) {
		return (String) tableModel.getValueAt(row, column);
	}
}
